var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export class Package {
    constructor(param) {
        this.deep = param.deep;
        this.name = param.name;
    }
    createEntity(name) {
        return {
            id: () => __awaiter(this, void 0, void 0, function* () {
                return yield this.id(this.name, name);
            }),
            idLocal: () => {
                return this.idLocal(this.name, name);
            },
            name: name
        };
    }
    id(...names) {
        return __awaiter(this, void 0, void 0, function* () {
            return yield this.deep.id(this.name, ...names);
        });
    }
    idLocal(...names) {
        return this.deep.idLocal(this.name, ...names);
    }
    applyMiniLinks() {
        return __awaiter(this, void 0, void 0, function* () {
            const { data: packageLinks } = yield this.deep.select({
                up: {
                    tree_id: {
                        _id: ["@deep-foundation/core", 'containTree']
                    },
                    parent_id: {
                        _id: [this.name]
                    }
                }
            });
            if (!packageLinks) {
                throw new Error(`Package with name ${this.name} is not found`);
            }
            this.deep.minilinks.apply(packageLinks);
        });
    }
}
//# sourceMappingURL=package.js.map